﻿(function () {

    "use strict";

    angular.module("enrDetailsPaneModule")
           .directive("detailsContactInfo", [function () {
               return {
                   templateUrl: "Scripts/EnrAngular/EnrDetailsPane/detailsContactInfo.html",
                   controller: "detailsContactInfoController",
                   scope: { },
                   restrict: "E"
               };
           }])
           .controller("detailsContactInfoController", ["$scope", "enrModeManager", "detailsViewModeManager", "detailsData", "detailsAddressInjector", "mapSelectedRegion", "officeJsonRegionFilter", function ($scope, enrModeManager, detailsViewModeManager, detailsData, detailsAddressInjector, mapSelectedRegion, officeJsonRegionFilter) {
               var navBarClass = "navbar navbar-default";

               // Details View Mode (Summary, County, etc...)
               $scope.navItemClicked = function (index) {
                   var newMode = index === 0 ? detailsViewModeManager.modeEnum.summary : detailsViewModeManager.modeEnum.county;
                   detailsViewModeManager.setCurMode(newMode);
               }
               $scope.$on(detailsViewModeManager.modeChangeEventName, function (event, newMode) {
                   $scope.summaryItemClass = "nav";
                   $scope.countyItemClass = "nav";

                   if (newMode === detailsViewModeManager.modeEnum.summary)
                       $scope.summaryItemClass += " active";
                   else
                       $scope.countyItemClass += " active";
               });
               detailsViewModeManager.setCurMode(detailsViewModeManager.modeEnum.summary);


               // Data Population
               var refreshDataBindingsOfficeMode = function() {
                   $scope.contactTitle = detailsData.getData().OfficeCategory.OFFICE_CATEGORY_NAME;

                   if (mapSelectedRegion.isAnyRegionSelected()) {
                       $scope.navBarClass = navBarClass + " hidden";
                       var regionData = officeJsonRegionFilter.getRegionNodes(detailsData.getData(), mapSelectedRegion.getSelectedRegionProperties())[0];

                       if (regionData !== undefined && regionData !== null) {
                           var isCounty = isNaN(regionData.MAP_JURISDICTION_NAME);
                           if (isCounty)
                               $scope.contactRegion = regionData.MAP_JURISDICTION_NAME.toUpperCase() + " COUNTY";
                           else
                               $scope.contactRegion = "DISTRICT " + regionData.MAP_JURISDICTION_NAME;

                           var addressInfoPresent = regionData.Office_Info !== undefined && regionData.Office_Info !== null;
                           if (addressInfoPresent) {
                               $scope.addressVisibility = "";
                               detailsAddressInjector.injectAddressInfo($scope, regionData.Office_Info);
                           } else
                               $scope.addressVisibility = "hidden";
                       } else {
                           $scope.contactRegion = "INDIANA STATE";
                           $scope.addressVisibility = "hidden";
                       }
                   }
                   else {
                       $scope.navBarClass = navBarClass;
                       $scope.contactRegion = "INDIANA STATE";
                       $scope.addressVisibility = "hidden";
                   }
               }
               var refreshDataBindingsReferendumsMode = function() {
                   $scope.contactTitle = "Referendums";
                   $scope.navBarClass = navBarClass + " hidden";

                   if (mapSelectedRegion.isAnyRegionSelected() && detailsData.isDataPresent()) {
                       $scope.contactRegion = detailsData.getData().Region.JURISDICTION_NAME.toUpperCase() + " COUNTY";
                       $scope.addressVisibility = "";
                       detailsAddressInjector.injectAddressInfo($scope, detailsData.getData().Region.Office_Info);
                   }
                   else {
                       $scope.contactRegion = "Select a County.";
                       $scope.addressVisibility = "hidden";
                   }
               }
               var refreshDataBindings = function () {
                   if (enrModeManager.isOfficeMode())
                       refreshDataBindingsOfficeMode();
                   else if (enrModeManager.isReferendumsMode())
                       refreshDataBindingsReferendumsMode();
               }
               $scope.$on(mapSelectedRegion.regionChangeEventName, function () {
                   refreshDataBindings();
               });
               $scope.$on(detailsData.dataChangedEventName, function () {
                   refreshDataBindings();
               });
           }]);

}());
